/********************************/
/* Closed Contour Class         */
/*******************************/
// Author: Ajay Mishra
// Created on: Mar 23, 2011
#include <cstdio>
#include <cv.h>
#include <highgui.h>
#include <time.h>
#include <cstdlib>
#include <iostream>
using namespace std;

struct BdPt{
  int x;
  int y;
  int objSide;
  double theta; // orientation between 0 and pi
  struct BdPt* next;
};

struct ROI{
  int x_o;
  int y_o;
  int w;
  int h;
};

class ClosedContour{
 private:
  const BdPt*  firstPt;
  BdPt* 	lastPt;
  ROI  	bdBox;
  int     isObject;
  int 	img_w;
  int 	img_h;
  int     fixPt_x;
  int     fixPt_y;
	/** for recognition */
	double* colorFeature;
	int     objectId;
 public:
		int 		numPts;
  //constuctor & destructors
  ClosedContour();
  ~ClosedContour();	
  void setROI(int& x, int& y, int& w, int& h);
  void setImgDims(int& w, int& h);
  void setFixPt(int x, int y);
  void setObjectFLAG(int& );
  void addBdPt(int& x, int& y, int& objSide, double&);
  
  //to read values!
  int getImgW(){ return img_w;}
  int getImgH(){ return img_h;}
  ROI getBdBox();
  CvPoint getFixPt();

  //manipluations!!
  IplImage* fillInside();
  bool isOverlapping(ClosedContour& );
	int  getFixPtsAlongMajorAxis(int& fixPt1_x, int& fixPt1_y, int& fixPt2_x, int& fixPt2_y);

  int myLabel(double** objColorFeature, int featureLen, int numObjs);
	bool extractColorFeatures(IplImage* imgc1c2c3, int nL, int na, int nb);

  //structure related
  CvPoint 	findObjectCenter(); 
  CvPoint3D64f 	findObjectCenter(double* ptCloud, int&, int&); 
  CvPoint3D64f 	findDominantSurfaceNormal(double* ptCloud); 
  
  //To investiage the immediate surrounding
  bool isInFrontOf(ClosedContour& );
  bool isTouching(ClosedContour& );
  
  //To Visualize!
  int draw(IplImage* canvass);	
  int draw(IplImage* canvass, CvScalar color);
}; 
